'Include file for betty.bas
'Program to track my home business transactions
'These include: services she renders
'               products she buys and sells
'               earnings she gets
'               business expenses she incurs
'-----------------------------------------------------------------------------------------
'Compiled with PowerBasic PBWin90 ver 9.01
'-----------------------------------------------------------------------------------------
'ver 2.00  (07-12-05)
' - added Earnings
' - added About()
' - improved coding
'ver 2.10  (07-18-07)
' - changed sales tax reporting to more accurately reflect the state form
'ver 2.20  (10-07-07)
' - expanded product form, improved sales tax entry
' - improved some sub and function names plus general code maintenance
'ver 2.21  (11-04-07)
' - added di.cbSize and di.lpszDocName to fix printing problem
' - corrected problem introduced by ver 2.20 (no OK button for short add form)
'ver 3.00  (08-24-08)
' - total rewrite of code for PB9
' - added tabs for easy viewing of particular transaction types
' - added descr and names list editing
' - added ability to archive data file
' - added help
'ver 3.01  (09-14-08)
' - added new subroutine 'createFolder'
' - uses proper data file locations (i.e., Documents and Settings for XP)
'ver 3.02  (09-20-08)
' - corrected problem editing transactions
'ver 3.03  (10-05-08)
' - added new feature, click headers to toggle ascending/descending sort
' - corrected a few problems with editing
' - removed transaction type options from filter dialog box (already covered by tabs)
'ver 3.04  (03-21-09)
' - improved label for amount field (to better correspond with tax options)
' - improved taxAmt control (readOnly style rather than disable)
'ver 3.05  (03-27-08)
' - fixed: added leading CHR$(typeX) to descr combo strings
' - fixed: fillLists(), added statement with variable m
'ver 3.06  (03-28-09)
' - fixed: problem changing bought to sold
' - fixed: data button not filling fields (added showTransXProc)
' - improved: remember position of showTransX dialog
'ver 3.07  (03-30-09)
' - fixed: several minor display problems
' - improved: find descriptions & names on entry
'ver 3.10  (04-21-09)
' - incorporate columnListClass.inc 
'ver 3.11  (07-19-09)
' - corrected bug resetting descr/names in filter function 
'ver 3.12  (07-27-09)
' - redefined variables recN0() --> recordNo() and hiLite --> highLite 
' - corrected bugs related to editing and viewing data
' - corrected bugs related to editing and viewing data from filtered lists
' - corrected bug showing record number in statusbar
'ver 3.13  (07-30-09), compiler 9.01
' - corrected problem typing name & descr past one character
' - corrected sales tax reporting (amt collected should be based on bought, not sold)
' - corrected deleted transX
'ver 3.14  (03-30-2010), compiler 9.02
' - corrected print... i = recordNo(oColList.getRecordNo(j))
' - corrected 'Orig cost' label to 'amount' for non-products
'ver 3.15  (05-25-2010), compiler 9.05
' - changed data storage from _DOCUMENTS to _APPDATA 
' - corrected createCtrl parameter (changed listID to id), showed up in 9.05 compiler
' - correction needed for PBWin10.4 (METHOD addItem in columnListClass)
'ver 3.16  (03-11-2021), compiler 10.04
' - various corrections for opening file 
'=================================================================================================

$fmt = "0.00"
%MAXTRANS = 5000
%MAXNAMES = 1000
%MAXDESCR = 500
%Service  = 1
%Expense  = 2
%Sold     = 3
%Bought   = 4
%Personal = 5
%Earnings = 6

'menu system ----------------
%IDM_FileOpen    = 101
%IDM_FileSave    = 102
%IDM_FileSaveAs  = 103 
%IDM_FileArchive = 104
%IDM_FilePrint   = 105
%IDM_FileExit    = 106 

%IDM_AddService  = 211
%IDM_AddEarning  = 212
%IDM_AddProduct  = 213
%IDM_AddExpense  = 214

%IDM_EditChange  = 201
%IDM_EditDelete  = 202
%IDM_EditNames   = 203
%IDM_EditDescr   = 204
%IDM_EditTax     = 205

%IDM_ViewAll     = 301
%IDM_ViewType    = 302
%IDM_ViewForm    = 303
%IDM_ViewFilter  = 304
%IDM_ViewReport  = 305

%IDM_HelpContent = 401
%IDM_HelpAbout   = 402

'toolbar ---------------------
%ID_Toolbar      = 1000
%ID_ServBtn      = 1001
%ID_ExpsBtn      = 1002
%ID_ProdBtn      = 1003
%ID_EarnBtn      = 1006
%ID_DataBtn      = 1007
%ID_EditBtn      = 1008
%ID_ReptBtn      = 1009
%ID_FilterBtn    = 1010
%ID_QuitBtn      = 1011

'tab control -----------------
%ID_TabCtrl      = 1100

'statusbar -------------------
%ID_Statusbar    = 1200
%ID_Stat1        = 1201
%ID_Stat2        = 1202

'listbox ---------------------
%ID_List         = 1300
%ID_DateHdr      = 1301
%ID_TypeHdr      = 1302
%ID_DescrHdr     = 1303
%ID_NameHdr      = 1304
%ID_AmountHdr    = 1305

'controls --------------------
%ID_DateTxt      = 2001
%ID_YearTxt      = 2002
%ID_DescrCmbo    = 2003
%ID_NamesCmbo    = 2004
%ID_LabelAmt     = 2005
%ID_Amount       = 2006
%ID_Handling     = 2007
%ID_Shipping     = 2008
%ID_TaxAmt       = 2009
%ID_TaxRate      = 2010
%ID_AddTaxOpt    = 2011
%ID_InclTaxOpt   = 2012
%ID_SpecifyOpt   = 2013
%ID_ResaleOpt    = 2014
%ID_Total        = 2015 
%ID_Clear        = 2021
%ID_OK           = 2022
%ID_NextBtn      = 2051
%ID_PrevBtn      = 2052
%ID_ChgTax       = 2053
%ID_SoldOpt      = 2054
%ID_BoughtOpt    = 2055
%ID_PersonalOpt  = 2056

'colList object ids
%ID_All          = 2501
%ID_Serv         = 2502
%ID_Earn         = 2503
%ID_Prod         = 2504
%ID_Exps         = 2505

'list editing
%ID_AllOpt       = 3001
%ID_ServOpt      = 3002
%ID_EarnOpt      = 3003
%ID_ProdOpt      = 3004
%ID_ExpsOpt      = 3005
%ID_UnusedOpt    = 3006

'Filter Dialog
%ID_StartTxt     = 3021
%ID_EndTxt       = 3022
%ID_YearCmbo     = 3023
%ID_Reset        = 3024

'Sales Tax Dialog
%ID_StateTax     = 4001
%ID_CountyTax    = 4002
%ID_LocalTax     = 4003
%ID_DistrictTax  = 4004
%ID_PrnRept      = 4005
%ID_Close        = 4006

'Process names/descr lists
%ID_Listbox      = 5000
%ID_Editbox      = 5001
%ID_Add          = 5002
%ID_Change       = 5003
%ID_Delete       = 5004
%ID_Combine      = 5005

TYPE transAction0         '22 bytes
     date AS WORD        'yyyyyyymmmmddddd
     typeX AS BYTE       'service, expense, sold, bought, personal, earnings (1,2,3,4,5,6)
     descr AS BYTE       'index of storDescr(), descr(i)=chr$(tag)+descr$
     names AS INTEGER    'index of storNames()
     amount AS LONG
     handling AS LONG
     shipping AS LONG
     tax AS LONG         '-1 indicates a resale with no tax collected (tax passed on to buyer)
END TYPE 

TYPE transAction         '30 bytes
     date AS WORD        'yyyyyyymmmmddddd
     typeX AS BYTE       'service, expense, sold, bought, personal, earnings (1,2,3,4,5,6)
     descr AS WORD       'index of storDescr(), descr(i)=chr$(tag)+descr$
     names AS WORD       'index of storNames(), names(i)=chr$(tag)+names$
     amount AS DWORD     'net amount of transaction
     handling AS DWORD   'cost of transaction handling
     shipping AS DWORD   'cost of transaction shipping
     taxOpt AS BYTE      'to be added, already included, specified, resale (0,1,2,3)
     taxRate AS SINGLE   'tax rate to be applied for taxOpt = 1,2
     taxAmt AS DWORD     'tax amount applied to transaction
     archive AS WORD     'archive year (2008)
END TYPE 

GLOBAL trans() AS transAction
GLOBAL storNames() AS STRING
GLOBAL storDescr() AS STRING
GLOBAL transType() AS STRING
GLOBAL reptData() AS STRING
GLOBAL reptVal() AS STRING
GLOBAL recordNo() AS LONG
GLOBAL tabHandle() AS LONG
GLOBAL tabstops() AS LONG
GLOBAL hMain AS LONG
GLOBAL hTab AS LONG
GLOBAL hAdd AS LONG
GLOBAL hTax AS LONG
GLOBAL hFilter AS LONG
GLOBAL hRept AS LONG
GLOBAL hList AS LONG
GLOBAL winWidth AS LONG
GLOBAL winHeight AS LONG
GLOBAL listX AS LONG
GLOBAL listY AS LONG
GLOBAL listW AS LONG
GLOBAL listH AS LONG
GLOBAL numDescr AS WORD
GLOBAL numNames AS WORD
GLOBAL numTrans AS WORD
GLOBAL nTab AS LONG
'GLOBAL listID AS LONG 
GLOBAL idList AS LONG 
GLOBAL sPage AS STRING
GLOBAL title AS STRING
GLOBAL stateTax AS DOUBLE, countyTax AS DOUBLE
GLOBAL localTax AS DOUBLE, districtTax AS DOUBLE
GLOBAL taxRate AS DOUBLE
GLOBAL thisFile AS STRING
GLOBAL dataFolder AS STRING
GLOBAL origDir AS STRING
GLOBAL fileChanged AS LONG
GLOBAL iniFileChanged AS LONG
GLOBAL index AS WORD
GLOBAL top AS WORD
GLOBAL highLite AS LONG  'WORD
GLOBAL showPrev AS BYTE
Global startDate As Word
GLOBAL endDate AS WORD
GLOBAL year AS STRING
GLOBAL typeX AS BYTE
GLOBAL descr AS LONG
GLOBAL names AS LONG
GLOBAL addDescr AS BYTE
GLOBAL addNameX AS INTEGER
GLOBAL showZero AS BYTE
GLOBAL numShown AS INTEGER
GLOBAL xPos, yPos AS LONG
GLOBAL oColList  AS iColumnList
GLOBAL oColList1 AS iColumnList
GLOBAL oColList2 AS iColumnList
GLOBAL oColList3 AS iColumnList
GLOBAL oColList4 AS iColumnList
GLOBAL oColList5 AS iColumnList

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
                           
'Program Notes
'-------------------------------------------------------------------------------------
'transactions = total list of all transactions
'records = those particular transactions being shown
'hiLite = selected record
'index  = selected transaction
'recNo(i) = transaction number shown
'recNo(hiLite) = selected transaction number
  